Subject: [v6ops] Route Information Option Lifetime

From: Timothy Winters <[email-masked]>
Date: Wed, 16 May 2012 11:51:22 -0400

Hello,
	6204bis has a requirement (L-3) that an IPv6 CE Router use the Route Information Option (RIO) for delegated prefixes.   The RIO option contains a lifetime field for the prefix, which should be populated with either the preferred or valid lifetime from a DHCP IA_PD option.  Using the valid lifetime from the PD for the life in the RIO makes sense as 4191 states the following for the route lifetime: 
		The length of time in seconds
      (relative to the time the packet is sent) that the prefix
      is valid for route determination. 

	The problem I'm currently seeing with this approach is L-14 
	"The IPv6 CE router MUST send an ICMPv6 Destination Unreachable
          message, code 5 (Source address failed ingress/egress policy)
          for packets forwarded to it that use an address from a prefix
          that has been deprecated."

	If the valid lifetime is used in the RIO, the host can attempt to route a deprecated prefix to a CE Router only to have the router respond with a ICMPv6 Error message.   It may make more sense to use the preferred lifetime as the value for the lifetime field in the RIO option. 

	What do others think about using the preferred lifetime to populate the RIO lifetime?

Regards,
Tim

---

From: Ole Trøan <[email-masked]>
Date: Wed, 16 May 2012 22:06:23 +0200

Tim,

> 	What do others think about using the preferred lifetime to populate the RIO lifetime?

the intention of L-14 was only for the router to send unreachable messages after the prefix was invalid. the use of "deprecated" isn't good, given that has a special meaning in 4861. I suggest 6204bis replaces "deprecated" with "invalidated".

would that resolve the ambiguity?

cheers,
Ole

---

From: Timothy Winters <[email-masked]>
Date: Wed, 16 May 2012 16:23:12 -0400

Hi Ole,
	It would but my main concern in this case would be for how long does the CE Router transmit the ICMP Unreachable message for a prefix that isn't valid?    

	Otherwise they will have to transmit ICMP Unreachable messages for all unrecognized  addresses which seems like overkill.

	For some reason, I thought the purpose of L-14 was to help flash renumbering, in that a CE Router would tell a host immediately the address was no longer useful instead of having to wait the two hours.   If not what is the purpose of generating the error message instead of just implementing BCP 38 [RFC 2827] and allowing the device to drop the packet silently?  

Regards,
Tim

---

From: "Bernie Volz (volz)" <[email-masked]>
Date: Wed, 16 May 2012 15:46:59 -0500

As clocks run at different speeds, I would think that there would be some (short) period beyond the expiration of the valid-lifetime a router would hold onto the route in case the devices' clocks were running slower than the router's.

This is very similar to what DHCP server do - they have a grace period (it often is configurable and can be set to 0). After a lease expires, the server doesn't reuse the lease for a different client until the grace period elapses just in case the client's clock ran slower.

That does mean the document likely needs to suggest a value for this grace period, or at least provide some discussion of what values might be reasonable. (While a fixed number is easy to implement, a percentage is likely more correct as clock drift is probably related to the duration of the drift.)

Note that ideally the CPE router and DHCP server (if their clocks ran at the same rate) would use the same value.

- Bernie

-----Original Message-----
From: [email-masked] [mailto:[email-masked]] On Behalf Of Timothy Winters
Sent: Wednesday, May 16, 2012 4:23 PM
To: Ole Trøan
Cc: IPv6 Operations
Subject: Re: [v6ops] Route Information Option Lifetime

Hi Ole,

Regards,
Tim

> would that resolve the ambiguity?

_______________________________________________
v6ops mailing list
[email-masked]
https://www.ietf.org/mailman/listinfo/v6ops

---

From: Ole Trøan <[email-masked]>
Date: Wed, 16 May 2012 23:55:06 +0200

Tim,

> 	What do others think about using the preferred lifetime to populate the RIO lifetime?

a retake after thinking about this some more.

L-14 is there to catch the case where a prefix has been invalidated or is unknown. the purpose is to inform the host that this address is now invalid. forwarding of packets for deprecated prefixes is perfectly fine, that may be part of normal renumbering. which is why I think L-14 needs clarification.

the lifetime to use for the RIO option is somewhat correlated to the lifetimes in the prefix, in that it doesn't make sense to claim to be a router for a prefix that it has no guarantee it owns after the PD valid lifetime has expired. I would suggest the RIO route lifetime to be the smaller of the default router lifetime and the valid lifetime.

if there is flash renumbering, there might be 'residual' connections still happening that will follow that route, the RIO route is only used to reach another part of the home network, and that could be made to work if the CE kept the more specific PD routes around. if not, then the host will get an ICMP back. I don't see how changing the RIO route life time for the PD prefix would matter.

cheers,
Ole

---

From: "Hemant Singh (shemant)" <[email-masked]>
Date: Wed, 16 May 2012 17:08:01 -0500

-----Original Message-----
From: [email-masked] [mailto:[email-masked]] On Behalf Of Ole Trøan
Sent: Wednesday, May 16, 2012 4:06 PM
To: Timothy Winters
Cc: IPv6 Operations
Subject: Re: [v6ops] Route Information Option Lifetime

>the intention of L-14 was only for the router to send unreachable messages after the prefix was invalid. the use of "deprecated" isn't >good, given that has a special meaning in 4861. I suggest 6204bis replaces "deprecated" with "invalidated".

RFC 4862 defines the lifetimes and the behavior.  See the first paragraph of section 5.5.4 of RFC 4862.  I agree the deprecated needs to change to invalidated in L-14.  

Hemant

---

From: "Hemant Singh (shemant)" <[email-masked]>
Date: Wed, 16 May 2012 17:57:55 -0500

-----Original Message-----

Sent: Wednesday, May 16, 2012 5:55 PM

To: Timothy Winters

Cc: IPv6 Operations

 

>the lifetime to use for the RIO option is somewhat correlated to the lifetimes in the prefix, in that it doesn't make sense to claim to be >a router for a prefix that it has no guarantee it owns after the PD valid lifetime has expired. I would suggest the RIO route lifetime to >be the smaller of the default router lifetime and the valid lifetime.

Default router lifetime is likely to me the winner in being small most of the time since RFC 4861 recommends the parameter to be 9000 secs.  

>if there is flash renumbering, there might be 'residual' connections still happening that will follow that route, the RIO route is only >used to reach another part of the home network, and that could be made to work if the CE kept the more specific PD routes around. if not, >then the host will get an ICMP back. I don't see how changing the RIO route life time for the PD prefix would matter.

Correct.  Specifically the MSR (RFC4191) was added to rfc 6204 to deal with hosts assigned with a ULA and ipv4 address and the hosts were using the ULA as source to reach the global Internet since the ULA has global scope.  

Hemant

---

From: Timothy Winters <[email-masked]>
Date: Thu, 17 May 2012 08:45:32 -0400

Hi Ole,
	Thanks for taking the time, so If I'm understanding you correctly a CE Router is expected to generate a ICMPv6 Unreachable message for all invalidated or unknown prefixes on the LAN interface?  This makes sense to me, I'm just making sure we don't expect a CE Router to know the difference between recently invalidated and unknown.

Regards,
Tim

Timothy Winters
UNH-IOL Senior IP Manager
603-421-4987

---

From: Ole Trøan <[email-masked]>
Date: Fri, 18 May 2012 09:40:24 +0200

Tim,

> 	Thanks for taking the time, so If I'm understanding you correctly a CE Router is expected to generate a ICMPv6 Unreachable message for all invalidated or unknown prefixes on the LAN interface?  Th…

yes, agree we should make no such expectation.

cheers,
Ole

---

From: "Weil, Jason" <[email-masked]>
Date: Mon, 21 May 2012 11:54:34 -0400

Ole/Tim,

I'd like to second the recommendation for invalidated vs deprecated in
requirement L-14 for the generation of an ICMP error messages.

I believe the original request for this requirement came from an
application developer. The fact that nobody seems to be arguing for the
former wording seems to imply that the new recommended wording is
justified.

Thanks,

Jason

On 5/18/12 3:40 AM, "Ole Trøan" <[email-masked]> wrote:

>Tim,
>
>>      Thanks for taking the time, so If I'm understanding you correctly a CE
>>Router is expected to generate a ICMPv6 Unreachable message for all
>>invalidated or unknown prefixes on the LAN interface?  This makes sense
>>to me, I'm just making sure we don't expect a CE Router to know the
>>difference between recently invalidated and unknown.
>

This E-mail and any of its attachments may contain Time Warner Cable proprietary information, which is privileged, confidential, or subject to copyright belonging to Time Warner Cable. This E-mail is intended solely for the use of the individual or entity to which it is addressed. If you are not the intended recipient of this E-mail, you are hereby notified that any dissemination, distribution, copying, or action taken in relation to the contents of and attachments to this E-mail is strictly prohibited and may be unlawful. If you have received this E-mail in error, please notify the sender immediately and permanently delete the original and any copy of this E-mail and any printout.